


#include "SDL.h"
#include "SDL_image.h"
#include "SDL_rotozoom.h"




SDL_Surface* screen;
int screen_flags;
SDL_Surface* s_chute;	/* For holding the basic ladder */
SDL_Surface* temp;



void change_screen(int x, int y)
  { 
  screen = SDL_SetVideoMode(x, y, 32, screen_flags);
  if (screen == NULL)
    {
    fprintf(stderr, "Error changing screen mode: %s\n", SDL_GetError());
    exit(1);
    }
  }

void init_SDL_stuff()
  { 
  if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER)==-1))
    {
    printf("Could not initialize SDL: %s.\n", SDL_GetError());
    exit(-1);
    }
    
 
    
  /* Clean up on exit */

  atexit(SDL_Quit);
 
    
  // Make the initial version of the main screen
  screen_flags = SDL_SWSURFACE | SDL_SRCCOLORKEY;
  change_screen(640, 480);

  

  SDL_WM_SetCaption("Chutes and Ladders", "Chutes and Ladders");

  }


SDL_Surface*  makechute(int sx, int sy, int ex, int ey)
  {
  
  double angle;
  int height;

  int number;
  SDL_Rect srect;
  SDL_Rect drect;
  
  SDL_Surface * newbie;
  SDL_Surface * final;
  int x;

  height = sqrt( (ex-sx)*(ex-sx) + (ey-sy)*(ey-sy) + .5);

  angle = atan2(ey-sy, ex-sx) * (180 / 3.14159265358979) + 90;
  
  number = ((height - 30) / 10) + 1;

  height = number* 10 + 30;
  
  newbie = SDL_CreateRGBSurface(SDL_SWSURFACE, 20,height, 32,0,0,0,0);
  
  drect.x = 0;
  drect.y = 0;
  
  srect.x = 0;
  srect.y = 0;
  srect.w = 20;
  srect.h = 8;
  
  SDL_BlitSurface(s_chute, &srect, newbie, &drect);
  
  srect.h = 10;
  srect.y = 8;
  
  drect.y = 8;
  
  for (x = 0; x < number; x++)
    {
    SDL_BlitSurface(s_chute, &srect, newbie, &drect);
    drect.y += 10;
    }
  
  srect.h = 22;
  srect.y = 18;

  SDL_BlitSurface(s_chute, &srect, newbie, &drect);


  final = rotozoomSurface(newbie,angle,1, SMOOTHING_ON);

  free(newbie);

  // Need to blit onto screen

  return final;
  }


int main(int argc, char* argv[])
  {
  int height;
  
  SDL_Rect drect;

  SDL_Rect cheese;
  
  double angle;

  SDL_Event event;

  int x, y;
  
  init_SDL_stuff();
  
  
  s_chute = IMG_Load("./chute1.xpm");
  
 
  
  drect.y = 200;
  drect.x = 200;
  

  cheese.x = 200;
  cheese.y = 315;
  cheese.w = 200;
  cheese.h = 50;
  
  angle=0;
  height = 114;

  x = 200;
  y = 100;
  
  while (1)
    {
    
    temp = makechute(200,200,x,y);


    // Blit the image!
   

    SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 0,0,0));
    

    drect.y = 314 - temp->h;


    SDL_BlitSurface(temp, NULL, screen, &drect);

    SDL_FillRect(screen, &cheese, SDL_MapRGB(screen->format, 255,255,255));
    
    SDL_UpdateRect(screen, 0,0,0,0);

   
    SDL_FreeSurface(temp);

    SDL_WaitEvent(&event);
    switch(event.type)
      {
      case SDL_KEYUP:
	if (event.key.keysym.sym==SDLK_RIGHT)
	  {
	  x+= 48;
	  if (x > 500) x = 500;
	  }
	if (event.key.keysym.sym==SDLK_LEFT)
	  {
	  x-=48;
	  if (x < 50) x = 50;
	  }

	if (event.key.keysym.sym==SDLK_UP)
	  {
	  y -= 48;
	  if (y < 40) y= 40;
	  }
	if (event.key.keysym.sym==SDLK_DOWN)
	  {
	  y += 48;
	  if (y > 200) y = 200;
	  }
	
	if (event.key.keysym.sym==SDLK_ESCAPE)
	  {
	  printf("Quit Button pressed\n");
	  exit(0);
	  }
	
	break;
      case SDL_QUIT:
	printf("SDL QUIT called \n");
	exit(0);
	break;
      }

    
    }



  }

