
#include "SDL_rotozoom.h"

#include "./image/ladder1.xpm"
#include "./image/chute1.xpm"

SDL_Surface * s_chute;
SDL_Surface * s_ladder;

char location[1000];


void makechute(int sx, int sy, int ex, int ey)
  {
  
  double angle;
  int height;

  int number;
  SDL_Rect srect;
  SDL_Rect drect;
  
  SDL_Surface * newbie;
  SDL_Surface * final;
  int x;

  height = sqrt( (ex-sx)*(ex-sx) + (ey-sy)*(ey-sy) + .5);

  angle = atan2(ey-sy, ex-sx) * (180 / 3.14159265358979) - 90;
  
  number = height;
  
  newbie = SDL_CreateRGBSurface(SDL_SWSURFACE, 20,height, 32,0,0,0,0);
   printf("Unrotated chute format = %d\n", newbie->format->BitsPerPixel);
  drect.x = 0;
  drect.y = 0;
  
  srect.x = 0;
  srect.y = 0;
  srect.w = 20;
  srect.h = 1;
  
  for (x = 0; x < number; x++)
    {
    SDL_BlitSurface(s_chute, &srect, newbie, &drect);
    drect.y += 1;
    }
  
  final = rotozoomSurface(newbie,-angle,1, SMOOTHING_ON);
 printf("Roto format = %d\n", final->format->BitsPerPixel);
  SDL_FreeSurface(newbie);

  // Need to blit onto screen
  if (sx < ex) drect.x = sx;
  else drect.x = ex;

  if (sy < ey) drect.y = sy;		       
  else drect.y = ey;

   SDL_SetColorKey(final, SDL_SRCCOLORKEY,
		  SDL_MapRGB(final->format,0,0,0));
 printf("Roto format = %d\n", final->format->BitsPerPixel);
  SDL_BlitSurface( final,NULL, board,  &drect);
  
  SDL_FreeSurface(final);
  }

void makeladder(int sx, int sy, int ex, int ey)
  {
  int height;
  double angle;

  int number;      // Number of ladder segments
  SDL_Rect srect;  // Source for ladder component
  SDL_Rect drect;  // Where to blit ladder component in ladder
  
  SDL_Surface * newbie; // Unrotated ladder
  SDL_Surface * final;  // Rotated ladder

  int x;  // Induction var 
    
  printf("At start %d, %d to %d, %d\n", sx, sy, ex, ey);

  height = sqrt( (ex-sx)*(ex-sx) + (ey-sy)*(ey-sy) + .5);

  angle = atan2(ey-sy, ex-sx) * (180 / 3.14159265358979) -90;
  
  number = ((height - 9) / 15) + 1;
  height = number* 15 + 9;
  
  newbie = SDL_CreateRGBSurface(SDL_SWSURFACE, 20,height, 32,0,0,0,0);
  
  drect.x = 0;
  drect.y = 0;
  
  srect.x = 0;
  srect.y = 0;
  srect.w = 20;
  srect.h = 9;
  
  SDL_BlitSurface(s_ladder, &srect, newbie, &drect);
  
  srect.h = 15;
  srect.y = 9;
  
  drect.y = 9;
  
  for (x = 0; x < number; x++)
    {
    SDL_BlitSurface(s_ladder, &srect, newbie, &drect);
    drect.y += 15;
    }
  
  final = rotozoomSurface(newbie,-angle,1, SMOOTHING_ON);

  SDL_FreeSurface(newbie);


  // Need to blit onto screen
  if (sx < ex) drect.x = sx;
  else drect.x = ex;

  if (sy < ey) drect.y = sy;		       
  else drect.y = ey;

  SDL_SetColorKey(final, SDL_SRCCOLORKEY,
		  SDL_MapRGB(final->format,0,0,0));

  SDL_BlitSurface(final,NULL,  board, &drect);
  
  SDL_FreeSurface(final);

  return ;
  }

void read_config(char *name)
  {
  FILE* infile;

  int s;
  int e;

  char str[150];
  char loc[1000];

  s_chute = IMG_ReadXPMFromArray(chute1_xpm);
  s_ladder = IMG_ReadXPMFromArray(ladder1_xpm);

  strcpy(location, name);

  sprintf(loc, "./%s/%s.config", location, location);
 
  infile = fopen(loc, "r");
 
  while (fscanf(infile, "%d",&s)!= EOF)
    {
    //fgets(blist[s]->stext, 80,  infile);
    fscanf(infile, "%d", &e);
    fgets(blist[s]->stext, 80,  infile);
    //fgets(blist[e]->etext, 80, infile);
    blist[s]->jump = e;
    // Will need to draw the chutes and ladders later!

    if (e > s) 
      {
      makeladder(blist[s]->loc.x+14, blist[s]->loc.y+16,
		 blist[e]->loc.x+14, blist[e]->loc.y+16);
      }
    else
      makechute(blist[s]->loc.x+14, blist[s]->loc.y+16,
		blist[e]->loc.x+14, blist[e]->loc.y+16);
    
    }

  }
