

#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_rotozoom.h"
// Cygwin does not have random 
#ifdef WIN32 
#define RAND rand
#endif
#ifndef WIN32 
#define RAND random  
#endif





#include "image/icon1.xpm"
#include "image/icon2.xpm"
#include "image/board.xpm"


struct SQUARE
  {
  int num;
  SDL_Rect loc;
  int jump;
  char stext[200];
  char etext[200];
  };
typedef struct SQUARE Square;

Square boardarray[10][10];
Square* blist[100];
SDL_Surface *board;

struct PLAYER
  {
  int loc;
  int status;
  SDL_Surface *icon;
  SDL_Rect src;
  SDL_Rect dest;
  };
typedef struct PLAYER Player;

Player player[2];

SDL_Surface *screen;
Uint32 screen_flags;

char *myfont;




#include "dice.c"
#include "ffont.c"
#include "config.c"


Mix_Chunk *turn[2];         // Holds dialog for announcing a players turn
Mix_Chunk *win[2];          // Holds dialog for announcing the winner

int display_note(char* str, int max, int x, int y, int w, int h)
  {
  char* start;
  char* curr;
  char* temp;
  char* end;

  int count;
  int total;

  int xcurr;

  char copy[80];

  
  curr = str;
  curr++;
  max -= 1;

  count = 0;
  total = 0;

  xcurr = x;

  

  while (curr[0] != '\0')
    {
    copy[count] = curr[0];
    curr++; count++; 

    if (curr[0] == ' ')
      {
      if (count + total > max)
	{
	total = 0;
	y += h; 
	xcurr = x;
	}
      copy[count] = '\0';
      
      stringRGBA(screen, xcurr, y, copy, 255, 255, 255, 255);
      total += count + 1;
      xcurr +=(w) * count + w ;
      count = 0;
      curr++;
      }
    if (count == max)
      {
      if (total != 0)
	{
	total = 0;
	y+= h;
	xcurr = x;
	}
      copy[count] = '\0';
     
      stringRGBA(screen, xcurr, y, copy, 255, 255, 255, 255);
      total = 0;
      y+= h;
      xcurr = x;
      count = 0;
      }

    } // End while
  if (count + total > max)
    {
    y+= h;
    xcurr = x;
    }
  copy[count-1] = '\0';
 
  stringRGBA(screen, xcurr, y, copy, 255, 255, 255, 255);
  }



void change_screen(int x, int y)
  {
  screen = SDL_SetVideoMode(x, y, 32, screen_flags);
  if (screen == NULL)
    {
    fprintf(stderr, "Error changing screen mode: %s\n", SDL_GetError());
    exit(1);
    }
  }

void init_SDL_stuff()
  {
  FILE* file;

int numtimesopened, frequency, channels;
Uint16 format;


  if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER)==-1))
    {
    printf("Could not initialize SDL: %s.\n", SDL_GetError());
    exit(-1);
    }
  
  if ( Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2,1024) == -1)
    {
    printf("Mix_OpenAudio error\n");
    printf("Oh My Goodness, an error : %s", Mix_GetError());
    exit(1);
    }
 


  /* Clean up on exit */
  
  atexit(SDL_Quit);
  atexit(Mix_CloseAudio);
  
  // Make the initial version of the main screen
  screen_flags = SDL_SWSURFACE | SDL_SRCCOLORKEY;
  change_screen(640, 480);
  
  
  
  SDL_WM_SetCaption("Chutes and Ladders", "Chutes and Ladders");
  
  Font_setup();


  // Set up gfx font array
  myfont=(char *)malloc(3328);
  file = fopen("./image/6x13.fnt","r");
  fread(myfont,3328,1,file);
  fclose(file);
  gfxPrimitivesSetFont(myfont,6,13);
  

  turn[0] = Mix_LoadWAV("./audio/player1.wav");
  turn[1] = Mix_LoadWAV("./audio/player2.wav");

  win[0] = Mix_LoadWAV("./audio/win1.wav");
  win[1] = Mix_LoadWAV("./audio/win2.wav");
  
  }






void slide (int who, int from, int to)
  {
  int sx, sy;
  int ex, ey;

  float x, xinc;
  float y, yinc;
  float iter;

  SDL_Rect c[3];
  int other;

  int dir;
  int start;
  int end;

 

  SDL_Surface * Backing;

  // Need to erase old character position
  c[0].x =blist[player[who].loc]->loc.x; c[0].y =blist[player[who].loc]->loc.y;
  c[0].w =blist[player[who].loc]->loc.w; c[0].h =blist[player[who].loc]->loc.h;

  if (who == 0) other = 1;
  else other = 0;
  
  c[1].x = player[other].dest.x;  c[1].y = player[other].dest.y;
  c[1].w = player[other].dest.w;  c[1].h = player[other].dest.h;
  
  SDL_BlitSurface(board, &c[0], screen , &c[0]);
  SDL_BlitSurface(player[other].icon, &player[other].src, screen, &c[1]);
  
  SDL_UpdateRects(screen, 2, c);
  
  Backing = SDL_CreateRGBSurface(SDL_SWSURFACE, 20,20, 32,0,0,0,0);

  sx = player[who].dest.x;
  sy = player[who].dest.y;

  
  ex = blist[to]->loc.x +14;
  ey = blist[to]->loc.y +14;
   

  if ((abs(ey-sy) > abs(ex-sx)))
    {
    printf("y Loop\n");
    // The for loop should iterate though the y's
    x = sx;  xinc = (float)(ex-sx)/abs((ey-sy));
    SDL_BlitSurface( screen, &player[who].dest, Backing, NULL);
    if (ey > sy)
      {
      start = sy; end = ey; dir = +1;
      }
    else
      {
      start = sy; end = ey; dir = -1;
      }
    printf("Staring y loop with star = %d, end = %d, dir = %d\n", start, end, dir);
    for (iter = start; iter != end; iter+= dir)
      {
      SDL_BlitSurface(Backing, NULL, screen, &player[who].dest);
      x += xinc;
      player[who].dest.x = x;
      player[who].dest.y = iter;
      
      SDL_BlitSurface( screen, &player[who].dest, Backing, NULL);

      SDL_BlitSurface(player[who].icon, &player[who].src,
		      screen, &player[who].dest);
      SDL_UpdateRect(screen, 0,0,0,0);
      SDL_Delay(50);
      }
    }
  else
    {
    printf("x loop\n");
   // The for loop should iterate though the x's
    y = sy;  yinc = (float)(ey-sy)/abs((ex-sx));
    SDL_BlitSurface( screen, &player[who].dest, Backing, NULL);
    if (ex > sx)
      {
      start = sx; end = ex; dir = +1;
      }
    else
      {
      start = sx; end = ex; dir = -1;
      }
    printf("Staring x loop with star = %d, end = %d, dir = %d\n", start, end, dir);
    for (iter = start; iter != end; iter+= dir)
      {
      SDL_BlitSurface(Backing, NULL, screen, &player[who].dest);
      y += yinc;
      player[who].dest.x = iter;
      player[who].dest.y = y;
      
      SDL_BlitSurface( screen, &player[who].dest, Backing, NULL);

      SDL_BlitSurface(player[who].icon, &player[who].src,
		      screen, &player[who].dest);
      SDL_UpdateRect(screen, 0,0,0,0);
      SDL_Delay(50);
      }
    }


  SDL_BlitSurface( screen, &player[who].dest, Backing, NULL);
  SDL_UpdateRect(screen, 0,0,0,0);

  }





void setup_board(int argc, char* argv[])
  {
  int x;
  int y;

  int temp;

  SDL_Surface* temp_board;

  SDL_Rect src;
  SDL_Rect dest;

 
  char str[4];
  char which[100];

  temp_board = IMG_ReadXPMFromArray(board_xpm);

  board = SDL_ConvertSurface(temp_board, screen->format, SDL_SWSURFACE);

  SDL_FreeSurface(temp_board);

  printf("Board format = %d\n", board->format->BitsPerPixel);

  for (y = 0; y < 10; y++)
    {
    for (x = 0; x < 10; x++)
      {
      
      boardarray[y][x].num = y * 10 + x;
	
      if (y %2 == 0)
	boardarray[y][x].loc.x = x * 48;
      else
	boardarray[y][x].loc.x = 432 - (x* 48);

      boardarray[y][x].loc.y = 432 - (y * 48);
      boardarray[y][x].loc.w = 48;
      boardarray[y][x].loc.h = 48;
      boardarray[y][x].jump = -1;  // Default is no jumping



      sprintf(str,"%d%d", boardarray[y][x].num / 10, boardarray[y][x].num %10);
      Font_Write(board, boardarray[y][x].loc.x + 2, boardarray[y][x].loc.y + 2,
		 str);
      
      }
    }
  SDL_UpdateRect(board, 0,0,0,0);
  // Board pointer array
  for (x = 0; x < 100; x++)
    {
    
      blist[x] = &boardarray[x/10][x%10];
  
    }


  
  // Now we need to insert the jumps for the squares that have them.
  if (argc == 1)
	  strcpy (which, "lssu");
  else
	  strcpy (which, argv[1]);
  read_config(which);


  // Write the board to the screen
  src.x = 0; src.y = 0; src.w = 480; src.h = 480;
  dest.x = 0; dest.y = 0; dest.w = 480; dest.h = 480;
  SDL_BlitSurface(board, &src, screen, &dest);
  SDL_UpdateRect(screen,0,0,0,0);
  }

void set_dest(int p, int s)
  {
  if (p == 0)
    {
    player[p].dest.x = blist[s]->loc.x + 4;
    player[p].dest.y = blist[s]->loc.y + 4;
    }
  if (p == 1)
    {
    player[p].dest.x = blist[s]->loc.x + 24;
    player[p].dest.y = blist[s]->loc.y + 24;
    }

  player[p].dest.w = 20;
  player[p].dest.h = 20;

  printf("Player %d is set to (%d, %d) w = %d  h = %d\n", p, 
	 player[p].dest.x,
	 player[p].dest.y,
	 player[p].dest.w,
	 player[p].dest.h);

  }

void setup_players()
  {
  SDL_Rect c[2];

  player[0].loc = 0;
  player[1].loc = 0;

  player[0].icon = IMG_ReadXPMFromArray(icon1_xpm);
  player[1].icon = IMG_ReadXPMFromArray(icon2_xpm);

  SDL_SetColorKey(player[0].icon, SDL_SRCCOLORKEY,
		  SDL_MapRGB(player[0].icon->format,0,0,0));
  SDL_SetColorKey(player[1].icon, SDL_SRCCOLORKEY,
		  SDL_MapRGB(player[1].icon->format,0,0,0));

  player[0].status = 0;
  player[1].status = 0;

  player[0].src.x = 0;   player[0].src.y = 0;
  player[0].src.w = 20;  player[0].src.h = 20;

  player[1].src.x = 0;   player[1].src.y = 0;
  player[1].src.w = 20;  player[1].src.h = 20;

  // Set destination rectangle for current square (start)
  set_dest(0, 0);
  set_dest(1, 0);
  
  c[0].x = player[0].dest.x;
  c[0].y = player[0].dest.y;
  c[0].w = player[0].dest.w;
  c[0].h = player[0].dest.h;
  
  c[1].x = player[1].dest.x;
  c[1].y = player[1].dest.y;
  c[1].w = player[1].dest.w;
  c[1].h = player[1].dest.h;
  
  
  SDL_BlitSurface(player[0].icon, &player[0].src, screen, &c[0]);
  SDL_BlitSurface(player[1].icon, &player[1].src, screen, &c[1]);

  SDL_UpdateRects(screen, 2, c);
  }



int player_turn (int who)
  {
  int num;
  SDL_Rect c[3];
  int x;

  char turn_str[100];
  SDL_Rect blank;

  char audfile[100];
  Mix_Chunk *aud;
  int channel;

  channel = -1;
  sprintf(turn_str, "Player %d - Roll the die", who+1);
 
  stringRGBA(screen,490,230,turn_str,255,255,255,255);
  SDL_UpdateRect(screen, 490, 230, 150, 20);
  channel = Mix_PlayChannel(-1, turn[who], 0);
  while (Mix_Playing(channel) != 0) SDL_Delay(50);
  channel = -1;

  // Need to determine the number of squares to move!
  num = roll_die();

  if (player[who].loc + num > 99)
    num = 99 - player[who].loc;

  // Animation loop while we move them there.
  for (x = 0; x < num; x++)
    {
    c[0].x =blist[player[who].loc]->loc.x;
    c[0].y =blist[player[who].loc]->loc.y;
    c[0].w =blist[player[who].loc]->loc.w;
    c[0].h =blist[player[who].loc]->loc.h;

    player[who].loc++;
    set_dest(who, player[who].loc);

    c[1].x = player[0].dest.x;
    c[1].y = player[0].dest.y;
    c[1].w = player[0].dest.w;
    c[1].h = player[0].dest.h;
    
    c[2].x = player[1].dest.x;
    c[2].y = player[1].dest.y;
    c[2].w = player[1].dest.w;
    c[2].h = player[1].dest.h;

    SDL_BlitSurface(board, &c[0], screen , &c[0]);
    SDL_BlitSurface(player[0].icon, &player[0].src, screen, &c[1]);
    SDL_BlitSurface(player[1].icon, &player[1].src, screen, &c[2]);

    SDL_UpdateRects(screen, 3, c);
    
    SDL_Delay(800);
    }



  // Check to see if this square has a special move
      // If it does, move them to the new square
  if (blist[player[who].loc]->jump != -1)
    {
    sprintf(audfile, "./%s/square%02d.wav", location, player[who].loc);
    printf("Trying to play %s\n", audfile);
    aud = Mix_LoadWAV(audfile);
    if (aud != NULL)
      {
      
      channel = Mix_PlayChannel(-1, aud, 0);
      if (channel == -1)
	printf("Got a play error : %s\n", Mix_GetError());
      }


    display_note(blist[player[who].loc]->stext, 23, 490, 300, 6, 15);
    
    // Slide them to new locale
    slide(who, player[who].loc, blist[player[who].loc]->jump);

    // Now set their square
    player[who].loc = blist[player[who].loc]->jump;
    }

  blank.x = 490; blank.y = 230; blank.w = 150, blank.h = 200;
  SDL_FillRect(screen, &blank, SDL_MapRGB(screen->format,0,0,0));
  SDL_UpdateRect(screen, 490, 230, 150, 200);
 
  if (channel != -1)
    {
    while (Mix_Playing(channel) != 0) SDL_Delay(50);  
    
    Mix_FreeChunk(aud);
    }
  c[0].x =blist[player[who].loc]->loc.x;
  c[0].y =blist[player[who].loc]->loc.y;
  c[0].w =blist[player[who].loc]->loc.w;
  c[0].h =blist[player[who].loc]->loc.h;
  
  set_dest(who, player[who].loc);

  c[1].x = player[0].dest.x;
  c[1].y = player[0].dest.y;
  c[1].w = player[0].dest.w;
  c[1].h = player[0].dest.h;
  
  c[2].x = player[1].dest.x;
  c[2].y = player[1].dest.y;
  c[2].w = player[1].dest.w;
  c[2].h = player[1].dest.h;
  
  SDL_BlitSurface(board, &c[0], screen , &c[0]);
  SDL_BlitSurface(player[0].icon, &player[0].src, screen, &c[1]);
  SDL_BlitSurface(player[1].icon, &player[1].src, screen, &c[2]);
  
  SDL_UpdateRects(screen, 3, c);




  // Check to see if they are on the last square
  if (player[who].loc == 99)
    {
    return 1;
    }


  return 0;
  }


int main(int argc, char* argv[])
  {
  int done;               // If a player won the game
  int waiter;             // Used to wait until announcements are complete.

  // SDL Setup stuff goes here
  init_SDL_stuff();


  // Setup dice image
  dice_setup();


  // Board setup stuff goes here
  setup_board(argc, argv);


  // Player setup goes here
  setup_players();


  done = 0;
  while (1)
    {
    // Need to do player 1
   
    done = player_turn(0);
    if (done == 1)      // Check to see if player 1 just won the game.
      {
      waiter = Mix_PlayChannel(-1, win[0], 0);
      while (Mix_Playing(waiter) != 0) SDL_Delay(50);

      printf("Player 1 wins!\n");
      exit(1);
      }

    // Need to do player 2
   

    done = player_turn(1);
    if (done == 1)     // Check to see if player 2 just won the game.
      {
      waiter = Mix_PlayChannel(-1, win[1], 0);
      while (Mix_Playing(waiter) != 0) SDL_Delay(50);

      printf("Player 2 wins\n");
      exit(1);
      }
    }


  }











